subroutine getlam(n,p,x,sx,lambda,order,dist,ns,s,strech,vecx,tempsx);
integer n,p,ns,order(n)

double precision x(n,p),sx(n,p),s(ns,p),lambda(n),dist(n),tempsx(p),
	vecx(p),strech

#this subroutine assumes on input a set of p co-ordinate functions s
#defined on the integers 1 ... ns; ie a parametrized  curve.
# 
#It produces a vector of lambda and fitted values sx for each value of x
#
#
# stretch left and right end boundries by factor 1+strech
if(strech < 0d0) strech=0d0
if(strech > 2d0) strech=2d0
#
do j=1,p{
	s(1,j)=s(1,j)+strech*(s(1,j)-s(2,j));
	s(ns,j)=s(ns,j)+strech*(s(ns,j)-s(ns-1,j))
}
do i=1,n{
	do j=1,p {vecx(j)=x(i,j)}
	call lamix(ns,p,vecx,s,lambda(i),dist(i),tempsx);
	do j=1,p {sx(i,j)=tempsx(j)}
}
do i=1,n{order(i)=i}
call sortdi(lambda,order,1,n)
call newlam(n,p,sx,lambda,order)
return;
end;
subroutine newlam(n,p,sx,lambda,tag);
integer n,p,tag(n);

double precision sx(n,p),lambda(n),lami
lambda(tag(1))=0d0;
for(i=1;i<n;i=i+1){
	lami=0d0
	do j=1,p{
		lami=lami+(sx(tag(i+1),j)-sx(tag(i),j))**2
	}
	lambda(tag(i+1))=lambda(tag(i))+dsqrt(lami);
}
return;
end;#
subroutine lamix(ns,p,x,s,lambda,dismin,temps);
integer ns,p;
double precision lambda,x(p),s(ns,p),dismin,temps(p);
double precision  v(2,10),d1sqr,d2sqr,dismin,d12,dsqr,
	d1,w;
real lam,lammin;
integer left,right;
#
# look for the closest segment
dismin=1d60;lammin=1;
for(ik = 1;ik<ns;ik=ik+1){
	d1sqr=0.0;
	d2sqr=0.0;
	do j=1,p{
		v(2,j)=x(j)-s(ik,j);
		v(1,j)=s(ik+1,j)-s(ik,j);
		d1sqr=d1sqr+v(1,j)**2;
		d2sqr=d2sqr+v(2,j)**2;
	}
	if(d1sqr.lt.1d-8*d2sqr){
		lam=ik;
		dsqr=d2sqr;
	}
	else{
		d12=0d0;
		do j=1,p{
			d12  = d12+v(1,j)*v(2,j);
		}
		d1=d12/d1sqr;
		if(d1.gt.1d0){
			lam=ik+1;
			dsqr=d1sqr+d2sqr-2d0*d12;
		}
		else if(d1.lt.0.0){
			lam=ik;
			dsqr=d2sqr;
		}
		else { 
			lam=ik+(d1);
			dsqr=d2sqr-(d12**2)/d1sqr;
		}
	}
	if(dsqr.lt.dismin){
		dismin=dsqr;
		lammin=lam;
	}
}
left=lammin;
if(lammin.ge.ns) left=ns-1;
right=left+1;
w=dble(lammin-left);
do j=1,p{
	temps(j)=(1d0-w)*s(left,j)+w*s(right,j);
}
lambda=dble(lammin);
return;
end;
